local ro = "rocky"
local function L_ZCollide(mo1,mo2) -- from claribun
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end



freeslot("MT_HITBOXTHINGIEHOORAY")
local box = MT_HITBOXTHINGIEHOORAY


mobjinfo[MT_HITBOXTHINGIEHOORAY] = {
    doomednum = -1,
    spawnhealth = 1,
    spawnstate = S_INVISIBLE,
    deathstate = S_NULL,
    xdeathstate = S_NULL,
    deathsound = sfx_null,
    radius = 175*FRACUNIT,
    height = 175*FRACUNIT,
    flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

addHook("MobjThinker", function(mo)
    if not (mo.target and mo.target.valid) P_RemoveMobj(mo) return end
    local pmo = mo.target
	local player = pmo.player
    if leveltime/1 == 0
        mo.height = 0
    else
        mo.height = ((mobjinfo[mo.type].height)*player.mo.scale)
		mo.radius = ((mobjinfo[mo.type].radius)*player.mo.scale)
    end
	
	if mo.tics > 1
or mo.tics < 0
    mo.tics = 1
end
    
end, MT_HITBOXTHINGIEHOORAY)

local function functionthatdoesstuff(mo, mo2)
    if not (mo2.flags & MF_ENEMY) return end
	if (mo2.flags & MF_NOGRAVITY) then return end
	local box = MT_HITBOXTHINGIEHOORAY
	if (not L_ZCollide(mo,mo2)) then return end
    if not (mo and mo.valid) then return end
	if (not P_IsObjectOnGround(mo2)) then return end
		local pmo = mo.target
		local player = pmo.player
		local plmo = player.mo
		if not (player and player.valid) then return end
		if (not player.powers[pw_super]) then
		P_SetObjectMomZ(mo2,7*plmo.scale,true)
	else
		P_SetObjectMomZ(mo2,15*plmo.scale,true)
end
end


 
addHook("MobjCollide", functionthatdoesstuff, MT_HITBOXTHINGIEHOORAY)
addHook("MobjMoveCollide", functionthatdoesstuff, MT_HITBOXTHINGIEHOORAY)


local function lol(mo, mo2)
    if not (mo2.player and mo2.valid and mo2.player.valid) then return end
	if (G_CoopGametype() and CV_FindVar("friendlyfire").value == 0) then return end
	local box = MT_HITBOXTHINGIEHOORAY
	if (not L_ZCollide(mo,mo2)) then return end
    if not (mo and mo.valid) then return end
	if (not P_IsObjectOnGround(mo2)) then return end
		local pmo = mo.target
		local player = pmo.player
		local plmo = player.mo
		local me2 = mo2.player
	    local ma2 = me2.mo
		if (ma2 == plmo) then return end
		if not (player and player.valid) then return end
		if (not player.powers[pw_super]) then
		P_SetObjectMomZ(mo2,7*plmo.scale,true)
		P_InstaThrust(ma2,R_PointToAngle2(ma2.x,ma2.y,plmo.x,plmo.y), -20*FRACUNIT)
	else
		P_SetObjectMomZ(ma2,15*plmo.scale,true)
		P_InstaThrust(me2,R_PointToAngle2(ma2.x,ma2.y,plmo.x,plmo.y), -35*FRACUNIT)
	
end
end


 
addHook("MobjCollide", lol, MT_HITBOXTHINGIEHOORAY)
addHook("MobjMoveCollide", lol, MT_HITBOXTHINGIEHOORAY)

freeslot("S_SLAM","SPR_SLAM")

states[S_SLAM] = {
	sprite = SPR_SLAM,
	frame = A|FF_ANIMATE|FF_FULLBRIGHT,
	tics = 8,
	var1 = 4,
	var2 = 2,
	nextstate = S_SLAM
}
local blam = S_SLAM

local function CheckAndCrumble(mo, sec)-- by the person in the srb2 serber i forgo
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
  end
addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.pound then
P_SpawnGhostMobj(pmo)
end
if p.poundspeed then
p.poundspeed = p.poundspeed - 3*FRACUNIT/2
return p.poundspeed
end
end)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.pound then
P_SetObjectMomZ(pmo, p.poundspeed)
player.powers[pw_strong] = STR_HEAVY
end
end)

addHook("JumpSpinSpecial", function(player)
local p = player
local pmo = player.mo
if p.low then return end
if P_IsObjectInGoop(pmo) then return end
if pmo.state == S_PLAY_ROCC then return end
if pmo.skin ~= ro then return end
if (All7Emeralds(emeralds) and p.rings >= 50 and (not p.powers[pw_super])) then return end
if P_IsObjectOnGround(pmo) then return end
if p.powers[pw_carry] then return end
if p.pound then return end
if p.sprung then return end
if P_PlayerInPain(p) or p.playerstate == PST_DEAD then return end
if pmo.eflags & MFE_SPRUNG then return end
p.pound = true
player.powers[pw_strong] = STR_HEAVY
p.pflags = $1|PF_STASIS
p.poundspeed = -30*FRACUNIT
P_SetObjectMomZ(pmo, p.poundspeed)
end)

addHook("PlayerSpawn", function(p)
if (not p and p.valid) then return end
p.sprung = false
p.bam = nil
if p.mo.skin ~= ro then return end
p.pound = false
p.poundspeed = -30*FRACUNIT
end)
addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if P_IsObjectInGoop(pmo) and p.pound then
p.pound = false
end
end)


addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.pound and P_IsObjectOnGround(p.mo) then
local h = P_SpawnMobj(pmo.x, pmo.y, pmo.z, box)

h.target = p.mo
if p.powers[pw_super] then
for i = 1,10 do
local dust = P_SpawnMobj(pmo.x,pmo.y,pmo.z, MT_SPINDUST)
dust.angle = FixedAngle(i*36*FRACUNIT)
dust.scale = pmo.scale*3/2
dust.target = pmo
dust.height = dust.spriteyscale
dust.radius	= dust.spritexscale
P_InstaThrust(dust,dust.angle,FixedMul(pmo.scale,50*FRACUNIT))
end
P_StartQuake(50*FRACUNIT,10)
S_StartSound(pmo, sfx_pstop)
p.pound = false
player.powers[pw_strong] = $ & ~STR_HEAVY
CheckAndCrumble(p.mo, p.mo.subsector.sector)
else
for i = 1,10 do
local dust = P_SpawnMobj(pmo.x,pmo.y,pmo.z, MT_SPINDUST)
dust.angle = FixedAngle(i*36*FRACUNIT)
dust.scale = pmo.scale
dust.target = pmo
dust.height = dust.spriteyscale
dust.radius	= dust.spritexscale
P_InstaThrust(dust,dust.angle,FixedMul(pmo.scale,30*FRACUNIT))
end
P_StartQuake(20*FRACUNIT,5)
S_StartSound(pmo, sfx_pstop)
p.pound = false
player.powers[pw_strong] = $ & ~STR_HEAVY
CheckAndCrumble(p.mo, p.mo.subsector.sector)
end
end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if (P_PlayerInPain(p) or p.playerstate == PST_DEAD) and p.pound then
p.pflags = $ & ~PF_STASIS
p.pound = false
end
end)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if (not p.pound) then return end
if p.mo.eflags & MFE_SPRUNG
p.pound = false
p.sprung = true
S_StartSound(p.mo, sfx_sprong)
		p.mo.state = S_PLAY_SPRING
		p.mo.momz = $*5/4
	end
	end)
	
addHook("PlayerThink", function(p)
	if p.mo.skin ~= ro then return end
	if p.pound == true then
	if p.bam then return end
	p.bam = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_OVERLAY)
	p.bam.state = blam
	p.bam.target = p.mo
	p.bam.scale = p.mo.scale
	end
	if p.bam  and p.bam.valid and p.pound == false then
	P_RemoveMobj(p.bam)
	p.bam = nil
	end
	end)
	
addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.sprung == true and P_IsObjectOnGround(pmo) then
p.sprung = false
end
end)

addHook("ShouldDamage", function(mo,inflictor)
if (not mo and mo.player and mo.player.valid) then return end
local p = mo.player
local pmo = mo.player.mo
if pmo.skin ~= ro then return end
if (not inflictor and inflictor.valid and inflictor.type == (MT_SPIKE or MT_WALLSPIKE)) then return end
if p.pound then
P_KillMobj(inflictor,mo,mo)
return false
end
end, MT_PLAYER)






local function gp(mo2,mo1)
if not (mo1 and mo1.valid and mo1.flags & (MF_ENEMY)) then return end
if (not mo2 and mo2.valid and mo2.player.valid) then return end
if (mo2.player.mo.skin ~= ro) then return end
if mo1.z + mo1.height < mo2.z or (mo2.z + (mo2.height)) < mo1.z then return end
if mo2.player.pound ~= true then return end
P_DamageMobj(mo1,mo2,mo2,1)
end

addHook("MobjCollide", gp, MT_PLAYER)
addHook("MobjMoveCollide", gp, MT_PLAYER)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.powers[pw_carry] and p.pound then
p.pound = false
end
end)




