local ro = "rocky"

addHook("ThinkFrame", function()
	for player in players.iterate do
		if (player and player.valid)
		and (player.mo and player.mo.valid)
		local p = player
			if player.mo.skin == ro
				if P_IsObjectOnGround(player.mo)
				if not P_PlayerInPain(p) or p.playerstate == PST_DEAD
				if (p.cmd.buttons & BT_USE) then
					player.mo.spriteyscale = FRACUNIT/3
					p.low = true
				else
					player.mo.spriteyscale = FRACUNIT
					p.low = false
					end
					end
				end
			end
		end
	end
end, MT_PLAYER)

addHook("PlayerSpawn", function(player)
	player.low = false
end)

addHook("PlayerHeight", function(player)
	if player.mo.skin ~= ro return end
	
	if player.low
		return (P_GetPlayerSpinHeight(player)/2)
	end
end)

addHook("PlayerCanEnterSpinGaps", function(player)
	if player.mo.skin ~= ro return end
	
	if player.low
		return true
	end
end)