local ro = "rocky"

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.powers[pw_super] then return end
if P_PlayerInPain(player) and p.owchie == false then
for i = 1,P_RandomRange(5,10) do
local rock = P_SpawnMobj(pmo.x,pmo.y,pmo.z, MT_FALLINGROCK)
rock.angle = pmo.angle
rock.scale = pmo.scale
rock.target = pmo
P_SetObjectMomZ(rock,P_RandomRange(5,10)*pmo.scale, true)
P_InstaThrust(rock,rock.angle + FixedAngle(P_RandomRange(-10,10)*FRACUNIT),-10*FRACUNIT)
end
p.owchie = true
end
end)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if (not p.powers[pw_super]) then return end
if P_PlayerInPain(player) and p.owchie == false then
for i = 1,P_RandomRange(5,10) do
local rock = P_SpawnMobj(pmo.x,pmo.y,pmo.z, MT_FALLINGROCK)
rock.angle = FixedAngle(i*ANG10)
rock.scale = pmo.scale
rock.target = pmo
P_SetObjectMomZ(rock,P_RandomRange(5,10)*pmo.scale, true)
P_InstaThrust(rock,rock.angle,P_RandomRange(1,2)*pmo.scale)
p.owchie = true
end
end
end)


addHook("PlayerSpawn", function(player)
	player.owchie = false
	player.rockhaha = false
	player.rockwait = 0
end)

addHook("PlayerThink", function(player)
if player.owchie ~= false and (not P_PlayerInPain(player)) then
player.owchie = false
end
end)


freeslot(
	"SPR2_ROCC",
	"S_PLAY_ROCC",
	"sfx_lol",
	"sfx_erm"
)

local lol = sfx_lol
local erm = sfx_erm
local r = S_PLAY_ROCC
local spr = SPR2_ROCC
states[r] = {
    sprite = SPR_PLAY,
    frame = spr,
    var2 = 2,
    tics = 1*TICRATE,
    nextstate = S_PLAY_STND
}
sfxinfo[lol].caption = "Rocky From Befdi?!??!"
sfxinfo[erm].caption = "Parry!"

addHook("PlayerThink", function(p)
local pmo = p.mo
if pmo.skin ~= ro then return end
if p.rockhaha then return end
if p.rockwait then return end
if p.cmd.buttons & BT_CUSTOM2 then
if (not P_IsObjectOnGround(pmo)) then return end
p.rockhaha = true
pmo.state = r
p.rockwait = 2*TICRATE
S_StartSound(pmo, lol)
end
end)

addHook("PlayerThink", function(p)
local pmo = p.mo
if pmo.skin ~= ro then return end
if pmo.state ~= r then
p.rockhaha = false
end
end)

addHook("PlayerThink", function(p)
local pmo = p.mo
if pmo.skin ~= ro then return end
if pmo.state == r then
p.pflags = $1|PF_STASIS
else
S_StopSoundByID(pmo,lol)
p.pflags = $ & ~PF_STASIS
end
end)

addHook("ShouldDamage", function(mo,inflictor)
if (not mo.valid and mo.player and mo.player.valid) then return end
local rocky = mo.player
if mo.skin ~= ro then return end
if rocky.rockhaha ~= true then return end
if P_PlayerInPain(rocky) then return end
if (not inflictor and inflictor.valid) then return end
if not (inflictor.flags & MF_ENEMY) then return end
if (inflictor.flags & MF_NOGRAVITY) then return end
if (rocky.powers[pw_invulnerability] or rocky.powers[pw_super]) then return end
local inf = inflictor
local pow = P_SpawnMobj(inflictor.x,inflictor.y,inflictor.z, MT_TNTDUST)
pow.state = S_TNTBARREL_EXPL4
pow.scale = rocky.mo.scale
S_StartSound(rocky.mo,erm)
P_DoPlayerPain(rocky)
P_InstaThrust(rocky.mo,rocky.mo.angle,-20*FRACUNIT)
P_InstaThrust(inflictor,R_PointToAngle2(inf.x,inf.y,rocky.mo.x,rocky.mo.y), -50*FRACUNIT)
P_SetObjectMomZ(inflictor,10*FRACUNIT,false)
inflictor.flags = $ & ~MF_SPECIAL
inflictor.yow = true
inflictor.scoregive = rocky.mo
inflictor.wait = TICRATE/35
rocky.rockhaha = false
rocky.mo.state = S_PLAY_FALL
return false
end)

addHook("ShouldDamage", function(mo,inflictor)
if (not mo.valid and mo.player and mo.player.valid) then return end
local rocky = mo.player
if mo.skin ~= ro then return end
if rocky.rockhaha ~= true then return end
if P_PlayerInPain(rocky) then return end
if (not inflictor and inflictor.valid) then return end
if not (inflictor.flags & MF_ENEMY) then return end
if (rocky.powers[pw_invulnerability] or rocky.powers[pw_super]) then return end
if (inflictor.flags & MF_NOGRAVITY) then 
local inf = inflictor
local pow = P_SpawnMobj(inflictor.x,inflictor.y,inflictor.z, MT_TNTDUST)
pow.state = S_TNTBARREL_EXPL4
pow.scale = rocky.mo.scale
S_StartSound(rocky.mo,erm)
P_DoPlayerPain(rocky)
P_InstaThrust(rocky.mo,rocky.mo.angle,-20*FRACUNIT)
P_KillMobj(inf,rocky.mo,rocky.mo)
rocky.rockhaha = false
rocky.mo.state = S_PLAY_FALL
return false
end
end)

addHook("ShouldDamage", function(mo,inflictor)
if (not mo.valid and mo.player and mo.player.valid) then return end
local rocky = mo.player
if mo.skin ~= ro then return end
if rocky.rockhaha ~= true then return end
if P_PlayerInPain(rocky) then return end
if (not inflictor and inflictor.valid) then return end
if (rocky.powers[pw_invulnerability] or rocky.powers[pw_super]) then return end
if (inflictor.type == MT_FALLINGROCK and inflictor.target) then return end
if (not inflictor.target and inflictor.target.valid) then return end
if inflictor.target == rocky.mo then return end
local inf = inflictor
local pow = P_SpawnMobj(inflictor.x,inflictor.y,inflictor.z, MT_TNTDUST)
pow.state = S_TNTBARREL_EXPL4
pow.scale = rocky.mo.scale
S_StartSound(rocky.mo,erm)
P_DoPlayerPain(rocky)
P_InstaThrust(rocky.mo,rocky.mo.angle,-20*FRACUNIT)
rocky.rockhaha = false
rocky.mo.state = S_PLAY_FALL
return false
end)

addHook("MobjThinker", function(mo)
if not (mo and mo.valid) then return end
if not mo.yow then return end
if not (mo.flags & MF_ENEMY) then return end
if (mo.flags & MF_NOGRAVITY) then return end
if (not P_IsObjectOnGround(mo)) then
local dust = P_SpawnMobjFromMobj(mo,P_RandomRange(-50,50)*FRACUNIT,P_RandomRange(-50,50)*FRACUNIT,P_RandomRange(-50,50)*FRACUNIT, MT_SPINDUST)
dust.scale = mo.scale
mo.angle = $ + ANG10
mo.rollangle = $ + ANGLE_45
elseif P_IsObjectOnGround(mo) and mo.yow then
if mo.wait then return end
mo.yow = false
P_KillMobj(mo,mo.scoregive,mo.scoregive)
end
end, MT_NULL)

addHook("MobjThinker", function(mo)
if not (mo and mo.valid) then return end
if not mo.yow then return end
if not (mo.flags & MF_ENEMY) then return end
if (mo.flags & MF_NOGRAVITY) then return end
if P_IsObjectInGoop(mo) then
P_KillMobj(mo,mo.scoregive,mo.scoregive)
end
end,MT_NULL)

addHook("MobjSpawn", function(mo)
if not (mo and mo.valid) then return end
mo.wait = 0*TICRATE
end, MT_NULL)

addHook("PlayerThink", function(player)
local p = player
local pmo = player.mo
if pmo.skin ~= ro then return end
if p.rockwait then
p.rockwait = $ - 1
end
end)


addHook("MobjThinker", function(mo)
if not (mo and mo.valid) then return end
if not (mo.flags & MF_ENEMY) then return end
if mo.wait then
mo.wait = $ - 1
end
end, MT_NULL)