local ro = "rocky"

local function IsInZ(mobj, mo)--also from buggie the bug
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end


local function rockcollide(mo2,mo1)
if (G_CoopGametype() and CV_FindVar("friendlyfire").value == 0) then return end
if not (mo1.player and mo1.valid and mo1.player.valid) then return end
if (not mo2 and mo2.valid and mo2.target and mo2.target.valid) then return end
if (not mo2.target.player and mo2.target.player.valid and mo2.target.skin == ro) then return end
if not P_PlayerCanDamage(mo2.target.player,mo1.player.mo) then return end
if (mo1.player.powers[pw_invulnerability] or mo1.player.powers[pw_super]) then return end
if mo1.player.mo.z + mo1.player.mo.height < mo2.z or (mo2.z + (mo2.height)) < mo1.player.mo.z then return end
if mo1.player.mo == mo2.target then return end
if (mo1.player.rockhit == true) then return end
if mo2.target.player.powers[pw_super] then
local boom = P_SpawnMobj(mo2.x,mo2.y,mo2.z,MT_TNTDUST)
boom.scale = mo2.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(mo1,sfx_bkpoof)
P_DoPlayerPain(mo1.player,mo2.target,mo2)
P_DamageMobj(mo1.player.mo,mo2,mo2.target,1)
P_DamageMobj(mo1.player.mo,mo2,nil,1)
P_InstaThrust(mo1,R_PointToAngle2(mo1.x,mo1.y,mo2.x,mo2.y), -250*FRACUNIT)
P_SetObjectMomZ(mo1.player.mo,10*FRACUNIT,true)
print(mo2.target.player.name.."'s SUPER rock just hit "..mo1.player.name.."!")
P_KillMobj(mo2)
mo1.player.rockhit = true
else
local boom = P_SpawnMobj(mo2.x,mo2.y,mo2.z,MT_TNTDUST)
boom.scale = mo2.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(mo1,sfx_bkpoof)
P_DoPlayerPain(mo1.player,mo2.target,mo2)
P_DamageMobj(mo1.player.mo,mo2,mo2.target,1)
P_DamageMobj(mo1.player.mo,mo2,nil,1)
P_InstaThrust(mo1,R_PointToAngle2(mo1.x,mo1.y,mo2.x,mo2.y), -50*FRACUNIT)
P_SetObjectMomZ(mo1.player.mo,10*FRACUNIT,true)
print(mo2.target.player.name.."'s rock just hit "..mo1.player.name.."!")
P_KillMobj(mo2)
end
end

addHook("MobjCollide",rockcollide, MT_FALLINGROCK)
addHook("MobjMoveCollide",rockcollide, MT_FALLINGROCK)

local function roccollide(mo2,mo1)
if not (mo1 and mo1.valid and ((mo1.flags & MF_ENEMY) or (mo1.flags & MF_BOSS))) then return end
if (not mo2 and mo2.valid and mo2.target and mo2.target.valid) then return end
if (not mo2.target.player and mo2.target.player.valid and mo2.target.skin == ro) then return end
if mo1.z + mo1.height < mo2.z or (mo2.z + (mo2.height)) < mo1.z then return end
if mo2.target.player.powers[pw_super] then
if not P_PlayerCanDamage(mo2.target.player,mo1) then return end
local boom = P_SpawnMobj(mo2.x,mo2.y,mo2.z,MT_TNTDUST)
boom.scale = mo2.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(mo1,sfx_bkpoof)
P_DamageMobj(mo1,mo2,mo2.target, DMG_INSTAKILL)
P_KillMobj(mo2)
else
local boom = P_SpawnMobj(mo2.x,mo2.y,mo2.z,MT_TNTDUST)
boom.scale = mo2.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(mo1,sfx_bkpoof)
P_DamageMobj(mo1,mo2,mo2.target,1)
P_KillMobj(mo2)
end
end

addHook("MobjCollide",roccollide, MT_FALLINGROCK)
addHook("MobjMoveCollide",roccollide, MT_FALLINGROCK)


addHook("PlayerThink", function(player)
if player and player.valid
if player.rockhit == true and (not P_PlayerInPain(player)) then
player.rockhit = false
end
end
end)

addHook("ShouldDamage", function(target,inflictor)
if (not target.player and target.valid and target.player.valid) then return end
local player = target.player
if (inflictor.type ~= MT_FALLINGROCK) then return end
if (not inflictor.target and inflictor.target.valid) then return end
if inflictor.target ~= player.mo then return end
return false
end, MT_PLAYER)


local function rocspike(spike,rok)
if not (rok and rok.valid and rok.type == MT_FALLINGROCK) then return end
if not (rok.target and rok.target.player and rok.target.valid) then return end
if not IsInZ(spike,rok) then return end
local p = rok.target.player
local pmo = p.mo
if not (pmo.skin == ro) then return end
local boom = P_SpawnMobj(spike.x,spike.y,spike.z,MT_TNTDUST)
boom.scale = spike.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(pmo,sfx_bkpoof)
P_KillMobj(spike,pmo,pmo)
end

addHook("MobjCollide",rocspike, MT_SPIKE)
addHook("MobjCollide",rocspike, MT_WALLSPIKE)

local function souper(spike,roc)
if not (roc and roc.type == MT_PLAYER) then return end
if not (spike and spike.valid) then return end
if (not roc.player.powers[pw_super]) then return end
if not (IsInZ(spike,roc)) then return end
if spike.ow then return end
if roc.skin ~= ro then return end
local pmo = roc
local boom = P_SpawnMobj(spike.x,spike.y,spike.z,MT_TNTDUST)
boom.scale = spike.scale/2
boom.state = S_TNTBARREL_EXPL4
S_StartSound(pmo,sfx_bkpoof)
spike.ow = true
P_KillMobj(spike,pmo,pmo)
end

addHook("MobjCollide",souper, MT_SPIKE)
addHook("MobjCollide",souper, MT_WALLSPIKE)
addHook("MobjCollide",souper, MT_EGGMOBILE4_MACE)
addHook("MobjCollide",souper, MT_SMALLMACE)
addHook("MobjCollide",souper, MT_BIGMACE)
addHook("MobjCollide",souper, MT_POINTYBALL)
